Subject: Re: bug#32093: 27.0.50; M-x grep appends /dev/null to command line

From: Noam Postavsky <[email-masked]>
Date: Sun, 08 Jul 2018 08:19:47 -0400

David Kastrup <[email-masked]> writes:

> This code actually is considerably old, older than what I remember
> having worked (though it's sort of hard to tell since the results of
> autodetection are stored in a session).  So I consider it more likely
> that the more recent
>
> 644cdd1aa0a (Noam Postavsky          2016-09-13  646)     (when (eq grep-use-null-filename-separator 'auto-detect)

> is involved here.  At any rate, the principal problem here is that "git
> grep" is a grep-like command that will usually refuse to work on
> out-of-tree files (unless --no-index option is given).  So the results
> from any of the autodetection, based on searching the HELLO file, are
> sort-of random.

The reason for the current breakage is actually the changes to the HELLO
file, the string "English" is no longer at the beginning of the line
since [1: 3589c966b7].  The reason the auto detection previously worked,
despite HELLO not being in the current git repository, is that the
autodetection works with plain "grep", not "git grep".  Autodetection
happens before you get the prompt, so you haven't even typed in "git"
yet.

[1: 3589c966b7]: 2018-05-19 18:17:38 +0300
  Use Enriched mode in etc/HELLO to keep charset information
  https://git.savannah.gnu.org/cgit/emacs.git/commit/?id=3589c966b743850c29b89b83710783d4ea026770